%define anolis_release 2
# Run optional test
%bcond_without perl_ExtUtils_MakeMaker_enables_optional_test
# Do not export underspecified dependencies
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(File::Spec\\)\s*$
# Do not export private redefinitions
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\(DynaLoader|ExtUtils::MakeMaker::_version\\)

# Filter modules bundled for tests
%global __requires_exclude %{__requires_exclude}|^perl\\(MY)\s*$
%global __requires_exclude %{__requires_exclude}|^perl\\(TieIn)\s*$
%global __requires_exclude %{__requires_exclude}|^perl\\(TieOut)\s*$
%global __requires_exclude %{__requires_exclude}|^perl\\(MakeMaker::Test.*)\s*$
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}


%global cpan_name ExtUtils-MakeMaker

Name:           perl-%{cpan_name}
Epoch:          2
Version:        7.66
Release:        %{anolis_release}%{?dist}
Summary:        Create a module Makefile
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/%{cpan_name}
Source0:        https://cpan.metacpan.org/authors/id/B/BI/BINGOS/%{cpan_name}-%{version}.tar.gz
Patch0:         %{cpan_name}-7.36-USE_MM_LD_RUN_PATH.patch
Patch1:         %{cpan_name}-7.30-Link-to-libperl-explicitly-on-Linux.patch
Patch2:         %{cpan_name}-7.04-Unbundle-version.patch
Patch3:         %{cpan_name}-7.22-Unbundle-Encode-Locale.patch
Patch4:         %{cpan_name}-7.11-Provide-ExtUtils-MM-methods-as-standalone-ExtUtils-M.patch
BuildRequires:  coreutils
BuildRequires:  make
BuildRequires:  perl(lib)
BuildRequires:  perl(Cwd)
BuildRequires:  perl(vars)
BuildRequires:  perl(Carp)
BuildRequires:  perl(strict)
BuildRequires:  perl(Config)
BuildRequires:  perl(Encode)
BuildRequires:  perl(version)
BuildRequires:  perl(warnings)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Copy)
BuildRequires:  perl(File::Path)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(File::Spec) >= 0.8
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl-ExtUtils-ParseXS
BuildRequires:  perl(subs)
BuildRequires:  perl(base)
BuildRequires:  perl(less)
BuildRequires:  perl(POSIX)
BuildRequires:  perl(Pod::Man)
BuildRequires:  perl(overload)
BuildRequires:  perl(AutoSplit)
BuildRequires:  perl(File::Find)
BuildRequires:  perl(DynaLoader)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(Getopt::Long)
BuildRequires:  perl(Test::Harness)
BuildRequires:  perl(Text::ParseWords)
BuildRequires:  perl(File::Temp) >= 0.22
BuildRequires:  perl(CPAN::Meta) >= 2.143240
BuildRequires:  perl(ExtUtils::Install) >= 1.52
BuildRequires:  perl(ExtUtils::Manifest) >= 1.70
BuildRequires:  perl(Parse::CPAN::Meta) >= 1.4414
# threads::shared not used
BuildRequires:  perl(utf8)
# XSLoader not used
%if %{with perl_ExtUtils_MakeMaker_enables_optional_test}
# Optional tests
BuildRequires:  perl-devel
BuildRequires:  perl(B)
BuildRequires:  perl(PerlIO)
BuildRequires:  perl(ExtUtils::CBuilder)
# Keep YAML optional
# Keep YAML::Tiny optional
%endif
Requires:       perl(B)
Recommends:     perl(CPAN::Meta) >= 2.143240
Suggests:       perl(CPAN::Meta::Converter) >= 2.141170
# CPAN::Meta::Requirements to support version ranges
Requires:       perl(DynaLoader)
Requires:       perl(Data::Dumper)
Recommends:     perl(CPAN::Meta::Requirements) >= 2.130
# Encode is needed for producing POD with =encoding statement correctly
Requires:       perl(Encode)
%if !%{defined perl_bootstrap}
Recommends:     perl(Encode::Locale)
%endif
Requires:       perl(ExtUtils::Command) >= 1.19
Requires:       perl(ExtUtils::Install) >= 1.54
Requires:       perl(ExtUtils::Manifest) >= 1.70
# ExtUtils::XSSymSet is not needed (VMS only)
Suggests:       perl(JSON::PP)
Requires:       perl(File::Find)
Requires:       perl(Getopt::Long)
Requires:       perl(File::Spec) >= 0.8
# Optional Pod::Man is needed for generating manual pages from POD
Requires:       perl(POSIX)
Requires:       perl(Pod::Man)
Recommends:     perl(Time::HiRes)
Requires:       perl(Test::Harness)
Requires:       perl(Text::ParseWords)
# VMS::Filespec is not needed (VMS only)
# Win32 is not needed (Win32 only)
# If an XS module is compiled, xsubpp(1) is needed
Requires:       perl-ExtUtils-ParseXS
# These dependencies are weak in order to relieve building noarch
# packages from perl-devel and gcc. See bug #1547165.
# If an XS module is built, code generated from XS will be compiled and it
# includes Perl header files.
Recommends:     perl-devel
# If an XS module is built, the generated Makefile executes gcc.
Recommends:     gcc

BuildArch:      noarch
%description
Perl-ExtUtils-MakeMaker is a module designed to simplify the process of
building and installing Perl extensions on a wide range of platforms. It
provides a set of conventions for organizing code and resources, and automates
many of the tasks of compiling and installing extensions. The module generates
makefiles that can be used to build and install the extensions on a variety
of platforms, including Unix, Linux, Windows, and Mac OS X.

The module is part of the Perl core distribution and is widely used in the
Perl community. It is supported by a large number of Perl developers and has
a strong track record of reliability and stability. Perl-ExtUtils-MakeMaker
is particularly useful for developers who need to distribute their code in
the form of extensions that can be easily installed on a wide range of platforms.

Some of the key features of Perl-ExtUtils-MakeMaker include:

Automatic generation of makefiles that work on a variety of platforms
Support for building extensions that depend on external libraries and resources
Detailed documentation and examples of how to use the module
Integration with other tools in the Perl development ecosystem, such as CPAN
(the Comprehensive Perl Archive Network) and Perl Build Tools.
Overall, Perl-ExtUtils-MakeMaker is an essential tool for Perl developers who
need to build and distribute extensions that can run on a variety of platforms.

%package -n perl-ExtUtils-Command
Summary:        Perl routines to replace common UNIX commands in Makefiles
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
BuildArch:      noarch
Requires:       perl(Carp)
Requires:       perl(File::Copy)
Requires:       perl(File::Find)
Requires:       perl(File::Path)
# File::Spec not used
# VMS::Feature not used

%description -n perl-ExtUtils-Command
Perl-ExtUtils-Command is a module that provides a set of command-line
utilities that are useful for building and installing Perl modules,
extensions, and distributions. It is part of the Perl core distribution
and is widely used in the Perl community.

The module provides a number of commands that can be used to automate
various tasks in the build and installation process. Some of the key
commands provided by the module include:

"cp": This command is used to copy files from one directory to another.
It is commonly used to copy the files that make up a Perl module or
distribution from the development directory to the installation directory.

"mkdir": This command is used to create directories. It is commonly used to
create the directories that are needed to install a Perl module or distribution.

"rm": This command is used to remove files and directories. It is commonly
used to remove the files that were created during the build process after
they have been installed.

"test": This command is used to run tests on a Perl module or distribution.
It is commonly used to ensure that the module or distribution is working
correctly before it is installed.

One of the key benefits of Perl-ExtUtils-Command is that it provides a
consistent set of commands that work across different platforms. This makes
it easy to build and install Perl modules and distributions on a wide range
of systems without having to worry about platform-specific issues.

Overall, Perl-ExtUtils-Command is an essential tool for Perl developers who
need to build and distribute modules and distributions. It provides a powerful
set of command-line utilities that can be used to automate many of the tasks
involved in the build and installation process, and it is widely supported by
the Perl community.

%package -n perl-ExtUtils-MM-Utils
Summary:        ExtUtils::MM methods without dependency on ExtUtils::MakeMaker
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
BuildArch:      noarch

%description -n perl-ExtUtils-MM-Utils
The perl-ExtUtils-MM-Utils module is a part of Perl's ExtUtils framework, which is used for building
and installing Perl modules. This module provides a set of utilities that are commonly used by
other modules in the ExtUtils family.

One of the main functions of perl-ExtUtils-MM-Utils is to generate Makefile fragments. These
fragments contain the rules and dependencies needed to build a Perl module, and are used by the
Makefile.PL script that is typically included with a module. The module provides a number of
functions for generating these fragments, including WriteMakefile, which is used to generate the
main Makefile for the module.

In addition to generating Makefile fragments, perl-ExtUtils-MM-Utils provides functions for checking
for the presence of header files, libraries, and other components needed to build a module. These
functions include find_header, which searches for a specific header file, and find_installed_headers,
which returns a list of all installed headers that match a certain pattern.
Other functions provided by perl-ExtUtils-MM-Utils include prefix, which returns the installation
prefix for the current Perl installation, and catfile, which is used to concatenate path components
into a single path. The module also includes a number of constants that are used throughout ExtUtils,
such as INST_LIB, which specifies the directory where libraries should be installed.

Overall, perl-ExtUtils-MM-Utils is an essential module for developers who are building and installing
Perl modules using the ExtUtils framework. By providing a set of commonly used utilities and constants,
it simplifies the process of building, testing, and distributing Perl modules.

%package tests
Summary:        Tests for %{name}
Requires:       perl(Encode)
Requires:       perl(version)
Requires:       perl(Pod::Man)
Requires:       perl(File::Spec)
Requires:       perl-Test-Harness
Requires:       perl(CPAN::Meta) >= 2.143240
Requires:       perl(Parse::CPAN::Meta) >= 1.4414
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
%if %{with perl_ExtUtils_MakeMaker_enables_optional_test}
# Optional tests
Requires:       perl(B)
Requires:       perl-devel
Requires:       perl(PerlIO)
Requires:       perl(ExtUtils::CBuilder)
%endif

%description tests
Tests from %{name}-%{version}. Execute them
with "%{_libexecdir}/%{name}/test".

%package doc
Summary:	Doc files for %{name}
Requires:	%{name} = %{?epoch:%{epoch}:}%{version}-%{release}

%description doc
Doc files for %{name}

%prep
%autosetup -p1 -n ExtUtils-MakeMaker-%{version}
# Remove bundled modules
rm -rf bundled
perl -i -ne 'print $_ unless m{^bundled/}' MANIFEST
rm -rf t/lib/Test
perl -i -ne 'print $_ unless m{^t/lib/Test/}' MANIFEST
rm -rf lib/ExtUtils/MakeMaker/version{,.pm}
perl -i -ne 'print $_ unless m{^lib/ExtUtils/MakeMaker/version(?:/|\.pm)}' MANIFEST
rm -rf lib/ExtUtils/MakeMaker/Locale.pm
perl -i -ne 'print $_ unless m{^lib/ExtUtils/MakeMaker/Locale\.pm}' MANIFEST

%if !%{with perl_ExtUtils_MakeMaker_enables_optional_test}
# Remove optional tests
rm t/02-xsdynamic.t t/03-xsstatic.t
perl -i -ne 'print $_ unless m{^t/02-xsdynamic\.t}' MANIFEST
perl -i -ne 'print $_ unless m{^t/03-xsstatic\.t}' MANIFEST
perl -i -ne 'print $_ unless m{^t/unicode\.t}' MANIFEST
%endif

# Help file to recognise the Perl scripts and normalize shebangs
for F in `find t -name *.t`; do
    if head -1 "$F" | grep -q -e '^#!.*perl' ; then
        perl -MConfig -pi -e 's|^#!.*perl\b|$Config{startperl}|' "$F"
    else
        perl -i -MConfig -ple 'print $Config{startperl} if $. == 1' "$F"
    fi
    chmod +x "$F"
done

%build
BUILDING_AS_PACKAGE=1 perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}

# Install tests
mkdir -p %{buildroot}/%{_libexecdir}/%{name}
cp -a t %{buildroot}/%{_libexecdir}/%{name}
cat > %{buildroot}/%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/bash
set -e
# Lots of tests write into temporary files/directories. The easiest solution
# is to copy the tests into a writable directory and execute them from there.
DIR=$(mktemp -d)
pushd "$DIR"
cp -a %{_libexecdir}/%{name}/* ./
prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
popd
rm -rf "$DIR"
EOF
chmod +x %{buildroot}/%{_libexecdir}/%{name}/test

%{_fixperms} %{buildroot}/*

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man3/*
%{perl_vendorlib}/*
%exclude %dir %{perl_vendorlib}/ExtUtils/MM
%exclude %{_mandir}/man3/ExtUtils::Command.*
%exclude %{_mandir}/man3/ExtUtils::MM::Utils.*
%exclude %{perl_vendorlib}/ExtUtils/Command.pm
%exclude %{perl_vendorlib}/ExtUtils/MM/Utils.pm

%files -n perl-ExtUtils-Command
%dir %{perl_vendorlib}/ExtUtils
%{_mandir}/man3/ExtUtils::Command.*
%{perl_vendorlib}/ExtUtils/Command.pm

%files -n perl-ExtUtils-MM-Utils
%dir %{perl_vendorlib}/ExtUtils
%dir %{perl_vendorlib}/ExtUtils/MM
%{_mandir}/man3/ExtUtils::MM::Utils.*
%{perl_vendorlib}/ExtUtils/MM/Utils.pm

%files tests
%{_libexecdir}/%{name}

%files doc
%doc Changes CONTRIBUTING README

%changelog
* Tue Apr 11 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 7.66-2
- Add doc package

* Sat Feb 04 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 7.66-1
- update to 7.66

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 7.64-3
- rebuild with perl 5.36.0

* Tue Apr 26 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 7.64-2
- fix rpath

* Wed Apr 20 2022 gcdota930915 <taifu.gc@alibaba-inc.com> - 7.64-1
- Init from upstream version 7.64
